﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Runtime.CompilerServices;
using System.Threading.Tasks;
using UnityEngine;
using UnityEngine.Networking;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System.Threading;
using System.Collections;

public class ModUpdater : Mod
{

	public static string Temppath = Path.GetTempPath() + @"\RaftModUpdaterTemp";
	public static string WWWResult;
	public static ModUpdater instanceMod;

	public static HNotification notification;

	public static bool Autoupdate;

	public static string UnofficialFixes;

	public static bool ExtraSettingsAPI_Loaded = false; // This is set to true while the mod's settings are loaded

	public static bool SettingLoaded = false;

	public async void Start()
	{
		notification = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.spinning, "Loading ModUpdater...");


		instanceMod = this;
		Autoupdate = false;



		Debug.Log("[Modupdater] Loading unofficial fixes");
		Task GetFixes = (Task)GetUnofficialFixes();
		await GetFixes;
		Debug.Log("ModUpdater has been loaded!");
		notification.Close();
		StartCoroutine(InitAutoUpdate());
		//Debug.Log("Autoupdate: " + Autoupdate);



	}



	IEnumerator InitAutoUpdate()
	{
		while(SettingLoaded == false)
		{
			yield return new WaitForSeconds(0.01f);
		}
		if (Autoupdate == true)
		{
			Debug.Log("[ModUpdater] AutoUpdate mods");
			string[] str = new string[] { };
			UpdateAllMods(str);
		}

	}
	public static void ExtraSettingsAPI_ButtonPress(string name) // Occurs when a settings button is clicked. "name" is set the the button's name
	{
		if (name == "updateAllButton")
		{
			string[] str = new string[] { };
			UpdateAllMods(str);

		}
	}

	public static bool ExtraSettingsAPI_GetCheckboxState(string SettingName) => false;

	public static void ExtraSettingsAPI_Load() // Occurs when the API loads the mod's settings
	{
		Debug.Log("[Modupdater] Extra settings found");
		//Debug.Log("Checkbox state: " + ExtraSettingsAPI_GetCheckboxState("autoUpdate"));
		Autoupdate = ExtraSettingsAPI_GetCheckboxState("autoUpdate");
		SettingLoaded = true;


	}



	public static async Task GetUnofficialFixes()
	{

		UnityWebRequest uwrrrr = UnityWebRequest.Get("http://share.schafranski.de/raftmodding/unofficialfix.json");
		await uwrrrr.SendWebRequest();

		if (uwrrrr.isNetworkError)
		{
			//Debug.Log("Error While Sending: " + uwrrrr.error);
			Debug.Log("[Modupdater] Couldn't get unnoficial Fixes. Trying again!");
			Debug.Log("[Modupdater] Loading unofficial fixes...");
			Task GetFixes = (Task)GetUnofficialFixes();
			await GetFixes;

		}
		else
		{
			Debug.Log("[Modupdater] Got list of unofficial Fixes!");
			UnofficialFixes = uwrrrr.downloadHandler.text;
			//Debug.Log(UnofficialFixes);
		}
	}

	public void OnModUnload()
	{
		Debug.Log("ModUpdater has been unloaded!");
	}

	[ConsoleCommand(name: "UpdateAllMods", docs: "Updates all the installed mods to the newest version")]
	public static async void UpdateAllMods(string[] args)
	{
		Debug.Log("[Modupdater] Updating all mods!");
		notification = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.spinning, "Updating all Mods...");

		for (int i = 0; i < HMLLibrary.ModManagerPage.modList.ToArray().Length; i++)
		{
			Task UpdateTask = (Task)UpdateModFunc(HMLLibrary.ModManagerPage.modList[i].jsonmodinfo.name);
			await UpdateTask;


		}
		notification.Close();
		notification = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Finished Updating! Restart the Game!", 5, HNotify.CheckSprite);



	}

	[ConsoleCommand(name: "UpdateMod", docs: "Updates a specific mod")]
	public static async void UpdateMod(string[] args)
	{
		Debug.Log(string.Join(" ", args));
		Task UpdateTask = (Task)UpdateModFunc(string.Join(" ", args));
		notification = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.spinning, "Updating Mods...");
		await UpdateTask;
		notification.Close();
		notification = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Finished Updating! Restart the Game!", 5, HNotify.CheckSprite);

	}

	public static async Task UpdateModFunc(string modname)
	{
		HNotification notification2;


		bool UnofficialFix = false;

		Directory.CreateDirectory(Temppath);

		int index = 9999;


		Debug.Log("[Modupdater] Update mod " + modname);



		List<ModData> md = HMLLibrary.ModManagerPage.modList;


		for (int i = 0; i < HMLLibrary.ModManagerPage.modList.ToArray().Length; i++)
		{
			if (HMLLibrary.ModManagerPage.modList[i].jsonmodinfo.name == modname)
			{
				index = i;
			}



		}

		if (index == 9999)
		{
			Debug.Log("[Modupdater] The mod failed to Update! Does it even exist?");
			//notification2 = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "The mod failed to Update! Does it even exist?", 5, HNotify.ErrorSprite);

		}
		else
		{
			if (HMLLibrary.ModManagerPage.modList[index].jsonmodinfo.updateUrl.Contains("YOUR-MOD-SLUG-HERE"))
			{
				Debug.Log("[Modupdater] Mod not found on Raftmodding Server. Is it one of yours?");
				//notification2 = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Mod not found on Raftmodding Server. Is it one of yours?", 5, HNotify.ErrorSprite);

			}
			else
			{


				UnityWebRequest uwr = UnityWebRequest.Get(HMLLibrary.ModManagerPage.modList[index].jsonmodinfo.updateUrl);
				await uwr.SendWebRequest();

				if (uwr.isNetworkError)
				{
					Debug.Log("[Modupdater] Error While Sending: " + uwr.error);
					Debug.Log("[Modupdater] Couldn't update mod: " + modname);
					//notification2 = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Couldn't update mod: " + modname, 5, HNotify.ErrorSprite);

				}
				else
				{
					//Debug.Log("Received: " + uwr.downloadHandler.text);
					WWWResult = uwr.downloadHandler.text;
					//Debug.Log(WWWResult.ToString());

					if (WWWResult.ToString().ToLower().Contains("404"))
					{
						Debug.Log("[Modupdater] Mod not found on Raftmodding Server. Is it one of yours? If not it may be misconfigured. Update the mod manually and ping me and the author... Raft is not Shark Food got this issue.");
						//notification2 = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Mod not found on Raftmodding Server. Is it one of yours? If not it may be misconfigured. Update the mod manually and ping me (FranzFischer#6710) and the author... Raft is not Shark Food got this issue." + modname, 5, HNotify.ErrorSprite);

					}
					else {

						string LocalVersion = HMLLibrary.ModManagerPage.modList[index].jsonmodinfo.version;
						string RemoteVersion = WWWResult.ToString();

						LocalVersion = LocalVersion.ToLower().Replace("v", "");
						RemoteVersion = RemoteVersion.ToLower().Replace("v", "");

						string slug = HMLLibrary.ModManagerPage.modList[index].jsonmodinfo.updateUrl.Split('/')[6];
						//Debug.Log(slug);

						bool noNewUnofficial = false;

						if (UnofficialFixes.Contains(slug))
						{
							UnofficialFix = true;

						}
						if(LocalVersion.Contains("[unofficial]".ToLower()) == true)
						{
							UnofficialFix = false;
							noNewUnofficial = true;
						}

						Debug.Log(LocalVersion);
						Debug.Log(LocalVersion.Contains("[UNOFFICIAL]".ToLower()));

						if ((LocalVersion != RemoteVersion || UnofficialFix) && noNewUnofficial == false)
						{
							//A newer version is available. Go ahead and download it
							Debug.Log("[Modupdater] Download new Version");
							string url = "";
							if (UnofficialFix)
							{
								Debug.Log("[Modupdater] Download unofficial fix");
								JObject JsonContent = JObject.Parse(UnofficialFixes);
								JArray item = (JArray)JsonContent["urls"];

								for (int i = 0; i < item.Count; i++)
								{


									string nameofitem = (string)item[i]["slug"];
									if (nameofitem == slug)
									{
										url = (string)item[i]["discord-url"];
										break;
									}
									else
									{

									}
								}
								if (url.IsNullOrEmpty())
								{
									Debug.Log("[Modupdater] Unexpected error downloading the unofficial fix");
									url = "https://www.raftmodding.com/mods/" + slug + "/download?ignoreVirusScan=true";
								}


							}
							else
							{
								//Donwload example url https://www.raftmodding.com/mods/itemspawner/download?ignoreVirusScan=true
								url = "https://www.raftmodding.com/mods/" + slug + "/download?ignoreVirusScan=true";
							}

							//Debug.Log(url);
							UnityWebRequest uwrr = new UnityWebRequest(url);
							uwrr.downloadHandler = new DownloadHandlerBuffer();
							Debug.Log("[Modupdater] Downloading...");
							await uwrr.SendWebRequest();



							if (uwrr.isNetworkError)
							{
								Debug.Log("[Modupdater] Error While Sending: " + uwrr.error);
								Debug.Log("[Modupdater] Couldn't update mod: " + modname + ". No bytes found!");
								//notification2 = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Couldn't update mod: " + modname + ". No bytes found!", 5, HNotify.ErrorSprite);


							}
							else
							{

								// retrieve results as binary data



								byte[] results = uwrr.downloadHandler.data;

								string filename = "modinstaller." + slug + ".rmod";
								System.IO.File.WriteAllBytes(Temppath + @"\" + filename, results);
								File.Copy(Temppath + @"\" + filename, @"mods\" + filename, true);
								Debug.Log("[Modupdater] Finished Downloading " + modname);
								notification2 = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Finished Downloading " + modname, 5, HNotify.CheckSprite);


							}
						}
						else
						{
							Debug.Log("[Modupdater] There is no new version for " + modname);
							//notification2 = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "There is no new version for " + modname, 5, HNotify.ErrorSprite);


						}
					}

				}
			}
		}


	}


}

//Got this from: https://gist.github.com/krzys-h/9062552e33dd7bd7fe4a6c12db109a1a Credits going to this guy for saving my life XD
//I hate async functions XD

public class UnityWebRequestAwaiter : INotifyCompletion
{
	private UnityWebRequestAsyncOperation asyncOp;
	private Action continuation;

	public UnityWebRequestAwaiter(UnityWebRequestAsyncOperation asyncOp)
	{
		this.asyncOp = asyncOp;
		asyncOp.completed += OnRequestCompleted;
	}

	public bool IsCompleted { get { return asyncOp.isDone; } }

	public void GetResult() { }

	public void OnCompleted(Action continuation)
	{
		this.continuation = continuation;
	}

	private void OnRequestCompleted(AsyncOperation obj)
	{
		continuation();
	}
}

public static class ExtensionMethods
{
	public static UnityWebRequestAwaiter GetAwaiter(this UnityWebRequestAsyncOperation asyncOp)
	{
		return new UnityWebRequestAwaiter(asyncOp);
	}
}



